(ns wanijo.handler
  (:require [compojure.core :refer :all]
            [compojure.route :as route]
            [ring.middleware.defaults :refer [wrap-defaults site-defaults]]
            [ring.util.response :as rur]
            [hiccup.page :as hp]
            [wanijo.auth.routes :refer [auth-routes]]
            [wanijo.view :refer [layout]]))

(defn- home [_]
  (layout :title "home"))

(defroutes app-routes
  (routes auth-routes)
  (GET "/" [] home)
  (route/not-found "Not Found"))

(defn- wrap-login-redirect [handler]
  (fn [req]
    (let [ident (get-in req [:session :ident])
          uri (:uri req)]
      (println ident (:session req))
      (if (and (nil? ident)
               (not (or (clojure.string/ends-with? uri ".css")
                        (clojure.string/ends-with? uri ".js")
                        (= uri "/login-check")
                        (= uri "/login"))))
        (rur/redirect "/login")
        (handler req)))))

(def app
  (-> app-routes
      wrap-login-redirect
      (wrap-defaults site-defaults)))
